<?php 
  ##_____________________________________________________________________
  ##    copyright 2006 Assela Pathirana
  ##    UNDER GNU GPL
  ##    Version 0.2 (2006 Sept)
  ##_____________________________________________________________________
  ##
  ##    This program is free software; you can redistribute it and/or modify
  ##    it under the terms of the GNU General Public License as published by
  ##    the Free Software Foundation; either version 2 of the License, or
  ##    (at your option) any later version.
  ##
  ##    This program is distributed in the hope that it will be useful,
  ##    but WITHOUT ANY WARRANTY; without even the implied warranty of
  ##    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ##    GNU General Public License for more details.
  ##
  ##    You should have received a copy of the GNU General Public License
  ##    along with this program; if not, write to the Free Software
  ##    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
  ##
  ##    Inspired by gallery2wiki by Andres Obrero <andres.obrero@transarte.com> 
  ##

$wgExtensionFunctions[] = "wfFilelinkExtension";

function wfFilelinkExtension () {
  global $wgParser;
  global $wgHooks; 
  $wgHooks['ParserBeforeTidy'][] = 'filelinkDo' ;
}
function filelinkDo (&$parser, &$text){
#########new part###########
  static $done=0;
  if ( $done ) { 
    return;
  }
  $done=1;
############################
  global $wgRequest;
  global $wgFilelinkExtensionPath;
  global $wgScriptPath;
  global $wgUser;
  global $IP;
  $sk=$wgUser->getSkin();
  $action =  $wgRequest->getVal( 'action', false );
  //Are we in a edit page AND are we allowed to edit
  if(strtolower($action) == "edit" && $wgUser->isAllowed('edit')){  
  //strtolower^^ is not needed, but to  be safe
  //now we know that we are in the  edit dialog so add some javascript code to add a new button
  // This is done by mainfile.js
  //However, dynamic variables must be given externally. 
  //So here are the neede variables for mainfile.js
  $vars= "
  <script type='text/javascript' language='JavaScript'> ; 
  var filelinkextension_iconimage='"."$wgScriptPath/$wgFilelinkExtensionPath"."/filelinkbutton.jpg' //global variable
  var filelinkextension_childfile='"."$wgScriptPath/$wgFilelinkExtensionPath"."/childfile.html' //global variable
  </script>";
  //Read in the mainfile.js
  $jscript=file_get_contents("$IP/$wgFilelinkExtensionPath/mainfile.js");
  $text="
  <script type='text/javascript' language='JavaScript'> "
        .$jscript.
        "
         //Just an entry point for the child window to call insertTags() function in wikibits
          function insertTagsInMe(one,two,three){
              insertTags(one,two,three);
          }
        </script>".$text;	
  $text=$vars.$text;
 
  }else{
    //Either not an edit attempt, or not logged in 
    //Do nothing be silent without bothering innocent visitors. 
  }
}
?>
